<template>
  <div id="app_nav_wrapper" class="bt-container">
    <template v-if="$isPhone">
      <div style="position: relative">
        <router-link to="/">
          <div :class="$attachReactablePostfix('div1')">
            <span :class="$attachReactablePostfix('title', 'NNAppHeaderTitle')">PRESWOT</span>
          </div>
        </router-link>
        <router-link to="/a/student/NNclass" v-if="authType === 0" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div3')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderStudyingClasses')">{{ $t('HEADER.ENROLLED_CLASS') }}</span>
          </div>
        </router-link>
        <router-link to="/a/teacher/NNclass" v-if="authType === 1" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div3')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderTeachingClasses')">{{ $t('HEADER.ING_CLASS') }}</span>
          </div>
        </router-link>

        <!-- 로그인 전 -->
        <router-link to="/login" v-show="!isJwtValid">
          <div :class="$attachReactablePostfix('div4')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderLogin')">{{ $t('LOGIN.LOGIN_TITLE') }}</span>
          </div>
        </router-link>

        <!-- 로그인 후 -->
        <!-- {{ $t('HEADER.PROFILE_BUTTON') }}<i class="el-icon-arrow-down el-icon-right"></i> -->
        <div :class="$attachReactablePostfix('div4')" v-show="isJwtValid" @click="onClick('LOGOUT')">
          <span :class="$attachReactablePostfix('common', 'NNAppHeaderLogout')">{{ $t('HEADER.LOGOUT_BUTTON') }}</span>
        </div>
        <!-- *** 여기를 풀면 언어 설정 변경기능이 활성화됩니다. -->
        <div :class="$attachReactablePostfix('div5')">
          <el-dropdown @command="onClick">
            <span class="el-dropdown-link" style="color: white;">{{ $t('HEADER.LANG_INFO') }}<i class="el-icon-arrow-down el-icon--right"></i></span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="LOCALE_KO">한국어</el-dropdown-item>
              <el-dropdown-item command="LOCALE_EN">English</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </div>
      </div>
    </template>
    <template v-if="!$isPhone">
      <div style="position: relative">
        <router-link to="/">
          <div :class="$attachReactablePostfix('div1')">
            <span :class="$attachReactablePostfix('title', 'NNAppHeaderTitle')">PRESWOT</span>
          </div>
        </router-link>
        <!-- <logo-component></logo-component> -->
        <!-- 교수님께서 이쁘지 않다고 일단 막으라고 하심
        <img v-show="isJwtValid && nologo === true" :class="Logo(isJwtValid)" :src="logoSrc" style="width: 50px; height: 50px;">
        -->
        <!--
        <router-link to="/classes" v-if="authType !== 1" >
          <div :class="$attachReactablePostfix('div2')">
            <span :class="$attachReactablePostfix('common')">주제목록</span>
          </div>
        </router-link>
        -->
        <router-link to="/a/teacher/NNclass" v-if="authType === 1 || authType === 4" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div2_1')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderTeachingClasses')">{{ $t('HEADER.ING_CLASS') }}</span>
          </div>
        </router-link>

        <!--
        <router-link to="/classes" v-if="authType === 0||authType === 1">
          <div style="display:inline-block; position:absolute; top: 15px; left:230px;">
            <span class="normal">주제목록</span>
          </div>
        </router-link>
        -->
        <router-link to="/a/student/NNclass" v-if="authType === 0" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div2_1')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderStudyingClasses')">{{ $t('HEADER.ENROLLED_CLASS') }}</span>
          </div>
        </router-link>

        <router-link to="/a/affiliationAdmin/reqCreateClass" v-if="authType === 4" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div7')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderStudyingClasses')">{{ $t('HEADER.MANAGE_REQ_CREATE_CLASS') }}</span>
          </div>
        </router-link>

        <router-link to="/a/student/enroll/class" v-if="authType === 0" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div3')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderStudyingClasses')">{{ $t('HEADER.REG_COURSE') }}</span>
          </div>
        </router-link>
        <router-link to="/a/teacher/class/Manage" v-if="authType === 1 || authType === 4" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div3')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderTeachingClasses')">{{ $t('HEADER.MANAGE_COURSE') }}</span>
          </div>
        </router-link>
        <router-link to="/a/bank" v-if="authType === 1" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div7')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderLectureBank')">{{ $t('HEADER.LCT_BANK') }}</span>
          </div>
        </router-link>
        <router-link to="/a/openspace" v-if="authType === 0" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div8')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderOpenSpace')">{{ $t('HEADER.OPEN_SPACE') }}</span>
          </div>
        </router-link>
        <!--div style="display:inline-block; position:absolute; top: 15px; left:230px;" class="normal_manager" v-if="authType === 3" v-show="isJwtValid">
          <span>{{ $t('BOARD.SAVE') }}
            <ul>
        </router-link-->
        <router-link to="/a/error/manage" v-if="authType === 3" v-show="isJwtValid">
          <div style="display:inline-block; position:absolute; top: 15px; left:230px;" class="normal_manager" v-if="authType === 3" v-show="isJwtValid">
            <span>{{ $t('RECORD.ERROR_MANAGE') }}
            <!-- <ul> -->
              <!--
              <li>
                <router-link to="/a/register/uni" v-if="authType === 3" v-show="isJwtValid">대학
                </router-link>
              </li>
              <li>
                <router-link to="/a/register/dept" v-if="authType === 3" v-show="isJwtValid">학과
                </router-link>
              </li>
              <li>
                <router-link to="/a/register/teacher" v-if="authType === 3" v-show="isJwtValid">강사
                </router-link>
              </li>
              -->
              <!-- <li>
                <router-link to="/a/register/class" v-if="authType === 3" v-show="isJwtValid">{{ $t('TEACHER_CLASS.COURSE') }}
                </router-link>
              </li> -->
              <!--
              <li>
                <router-link to="/a/register/student" v-if="authType === 3" v-show="isJwtValid">학생
                </router-link>
              </li>
              <li>
                <router-link to="/a/register/bank" v-if="authType === 3" v-show="isJwtValid">강의은행그룹
                </router-link>
              </li>
              -->
            <!-- </ul> -->
            </span>
          </div>
        </router-link>
        <!--
        <div style="display:inline-block; position:absolute; top: 15px; left:365px;" class="normal_manager" v-if="authType === 3" v-show="isJwtValid">
          <span>조회하기
            <ul>
              <li>
                <router-link to="/a/view/uni" v-if="authType === 3" v-show="isJwtValid">대학</router-link>
              </li>
              <li>
                <router-link to="/a/view/dept" v-if="authType === 3" v-show="isJwtValid">학과</router-link>
              </li>
              <li>
                <router-link to="/a/view/teacher" v-if="authType === 3" v-show="isJwtValid">강사</router-link>
              </li>
              <li>
                <router-link to="/a/view/class" v-if="authType === 3" v-show="isJwtValid">주제</router-link>
              </li>
              <li>
                <router-link to="/a/view/student" v-if="authType === 3" v-show="isJwtValid">학생및성적표</router-link>
              </li>
              <li>
                <router-link to="/a/view/bank" v-if="authType === 3" v-show="isJwtValid">세션은행그룹</router-link>
              </li>
            </ul>
          </span>
        </div>
        -->

        <!--
        <div style="display:inline-block; position:absolute; top: 20px; left:632px;" v-if="authType === 0||authType === 1">
          <input v-model="testData" type="text" id="headerInput" class="inputtestclass" placeholder="Please input"/>
          <i class="el-icon-search" @click="onClick('asdfsadf')"></i>
        </div>
        -->

        <!-- 회원가입 막아놓기
        <router-link to="/tos" v-show="!isJwtValid">
          <div :class="$attachReactablePostfix('div4')">
            <span :class="$attachReactablePostfix('common')">회원가입</span>
            -->

        <!-- 로그인 전 -->
        <router-link to="/login" v-show="!isJwtValid">
          <div :class="$attachReactablePostfix('div4')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderLogin')">{{ $t('LOGIN.LOGIN_TITLE') }}</span>
          </div>
        </router-link>

        <router-link to="/register" v-show="!isJwtValid">
          <div :class="$attachReactablePostfix('div5')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderRegister')">회원가입</span>
          </div>
        </router-link>

        <!-- 로그인 후 -->
        <!-- <div :class="$attachReactablePostfix('div3_5')" v-show="isJwtValid">
          <span :class="$attachReactablePostfix('common', 'NNAppHeaderProfile')" @click="recordClick">
            <i class="el-icon-video-camera"></i>
            {{ recordingState ? $t('RECORD.RECORD_STOP') : $t('RECORD.RECORD_START') }}
          </span>
        </div> -->
        <router-link to="/a/profileEdit" v-show="isJwtValid">
          <div :class="$attachReactablePostfix('div4')">
            <span :class="$attachReactablePostfix('common', 'NNAppHeaderProfile')">{{ $t('HEADER.PROFILE_BUTTON') }}</span>
          </div>
        </router-link>
        <!-- {{ $t('HEADER.PROFILE_BUTTON') }}<i class="el-icon-arrow-down el-icon-right"></i> -->
        <div :class="$attachReactablePostfix('div5')" v-show="isJwtValid" @click="onClick('LOGOUT')">
          <span :class="$attachReactablePostfix('common', 'NNAppHeaderLogout')">{{ $t('HEADER.LOGOUT_BUTTON') }}</span>
        </div>
        <!-- *** 여기를 풀면 언어 설정 변경기능이 활성화됩니다. -->
        <div :class="$attachReactablePostfix('div6')">
          <el-dropdown @command="onClick">
            <span class="el-dropdown-link" style="color: white;">{{ $t('HEADER.LANGUAGE') }}<i class="el-icon-arrow-down el-icon--right"></i></span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="LOCALE_KO">한국어</el-dropdown-item>
              <el-dropdown-item command="LOCALE_EN">English</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </div>
        <i :class="$attachReactablePostfix('fas fa-wifi div9')">
          {{ pingErrorCount > 1 ? $t('PING.ERROR') : `${responseTime} ms` }}
        </i>
      </div>
    </template>
  </div>
</template>

<script src="https://kit.fontawesome.com/b6b48082f3.js" crossorigin="anonymous"></script>

<style lang="scss" scoped>
  #app_nav_wrapper {
    padding: 8px 0;
  }
  .div1 {
    display:inline-block;
    position:absolute;
    top: 14px;
    left:5%;
  }
  .div2 {
    display:inline-block;
    position:absolute;
    top: 15px;
    left:20%;
  }
  .div2_1 {
    @extend .div2;
  }
  .div3 {
    display:inline-block;
    position:absolute;
    top: 15px;
    left: 30%;
  }
  .div4 {
    display:inline-block;
    position:absolute;
    top: 15px;
    left: 81%;
  }
  .div3_5 {
    display:inline-block;
    position: absolute;
    top: 15px;
    left: 73%;
  }
  .div5 {
    display:inline-block;
    position:absolute;
    top: 15px;
    left:86%;
  }
  .div6 {
    cursor: pointer;
    display:inline-block;
    position:absolute;
    top: 15px;
    left: 92%;
  }
  .div7 {
    display:inline-block;
    position:absolute;
    top: 15px;
    left: 38%;
  }
  .div8 {
    display:inline-block;
    position:absolute;
    top: 15px;
    left: 41%;
  }  
  .div9 {
    position: absolute;
    top: 22px;
    color: white;
    font-size: 0.7em;
    left: -2%;
  }
  .title {
    width: 101px;
    height: 22px;
    font-family: Verdana;
    font-size: 18px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: normal;
    letter-spacing: normal;
    color: #ffffff;
  }
  .common {
    width: 45px;
    height: 14px;
    font-family: SpoqaHanSans;
    font-size: 13px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.17;
    letter-spacing: normal;
    color: #ffffff;
  }
  .common:hover {
    font-size: 13px;
    font-weight: bold;
    color: #20a0ff;
  }
  .normal_manager{
    width: 65px;
    height: 74px;
    font-family: SpoqaHanSans;
    font-size: 13px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.17;
    letter-spacing: normal;
    color: #ffffff;
  }
  .normal_manager:hover{
    font-size: 13px;
    font-weight: bold;
    color: #20a0ff;
  }

  .normal_manager ul{
    list-style:none;
    padding-left:10px;
    width:100px;
    background-color:#233656;
  }

  .normal_manager ul li{
    display:none;
    font-family: SpoqaHanSans;
    line-height: normal;
    padding:5px 2px 5px 0;
    height:25px;
  }

  .normal_manager:hover ul li{
    display:block;
  }

  .normal_manager ul li a{
    text-decoration:none;
    color:#ffffff;
  }

  .normal_manager ul li a:hover{
    color:#20a0ff;
  }

  #header2:hover {
    background-color:blueviolet;
  }

  .div1-phone {
    display:inline-block;
    position:absolute;
    top: 14px;
    left:5%;
  }
  .div2-phone {
    display:none;
  }
  .div2_1-phone {
    @extend .div3-phone;
  }
  .div3-phone {
    display:inline-block;
    position:absolute;
    top: 14px;
    left:35%;
  }
  .div4-phone {
    display:inline-block;
    position:absolute;
    top: 15px;
    left:60%;
  }
  .div5-phone {
    display:inline-block;
    position:absolute;
    top: 15px;
    left:80%;
  }
  .title-phone {
    width: 101px;
    height: 22px;
    font-family: Verdana;
    font-size: 18px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: normal;
    letter-spacing: normal;
    color: #ffffff;
  }
  .common-phone {
    width: 45px;
    height: 14px;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.17;
    letter-spacing: normal;
    color: #ffffff;
  }
  .common-phone:hover {
    font-size: 13px;
    font-weight: bold;
    color: #20a0ff;
  }
</style>

<script>
import { mapState, mapGetters, mapMutations } from 'vuex';
import utils from '../../utils';
import userService from '../../services/userService';
import createClass from '../../services/createClass';
import { pingUrl } from '../../services/config';


export default {
  name: 'AppHeader',
  data() {
    return {
      searchText: '',
      testFlag: false,
      testData: '',
      logoSrc: '',
      nologo: true,
      responseTime: 0,
      pingUpdateInterval: null,
      pingErrorCount: 0,
    };
  },
  computed: {
    ...mapState('auth', ['jwt', 'locale']),
    ...mapState('layout', ['isNavCollapsed']),
    ...mapGetters('auth', ['isJwtValid']),
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
    appTheme() {
      const vm = this;
      const path = vm.$route.path;
      if (path.includes('teacher')) {
        if (path.includes('live')) {
          return 'warning';
        }
        return 'primary';
      } else if (path.includes('student')) {
        return '';
      }
      return 'primary';
    },
    recordingState() {
      const vm = this;
      return vm.recording;
    }
  },
  props: {
    recording: Boolean,
  },
  mounted() {
    const vm = this;

    vm.pingUpdateInterval = setInterval(() => {
      let startTime;
      const xhr = new XMLHttpRequest();
      
      xhr.open('GET', `${pingUrl}/ping/${Math.random().toFixed(2)}`);
      xhr.setRequestHeader('x-access-token', utils.getJwtFromLocalStorage());
      xhr.onload = _ => {
        vm.responseTime = new Date().getTime() - startTime;
        vm.pingErrorCount = 0;
      };
      xhr.onerror = err => {
        vm.pingErrorCount += 1;
      }
      startTime = new Date().getTime();
      xhr.send();
    }, 10000);
  },
  methods: {
    ...mapMutations('layout', ['updateCollapse']),
    ...mapMutations('auth', ['updateJwt', 'updateTemporalJwt', 'updateLocale']),
    _changeLocale(locale) {
      const vm = this;
      vm.$i18n.locale = locale;
      vm.updateLocale({ locale });
    },
    onClick(type) {
      const vm = this;
      switch (type) {
        case 'TOGGLE_NAVIGATION': {
          vm.updateCollapse({
            isNavCollapsed: !vm.isNavCollapsed,
          });
          break;
        }
        case 'PROFILE': {
          vm.$router.push({
            name: 'Profile',
          });
          break;
        }
        case 'LOGOUT': {
          vm.updateJwt({
            jwt: '',
          });
          vm.updateTemporalJwt({
            jwt: '',
          });
          if (vm.$route.meta.auth) {
            vm.$router.push({ name: 'LandingPage' });
          }
          /*
          // TODO: translation
          vm.$notify({
            title: '로그아웃',
            message: '로그아웃 성공',
            type: 'success',
          });
          */
          setTimeout(() => {
            location.reload();
          }, 800);
          // 이것을 하지 않으면, student로 들어갔다가 로그아웃하고 teacher로 들어간 후, 강의중인 강의 목록을 봤을때 텅 빈걸로 나오는 경우가 있음
          // 이떄, 화면을 새로 고치면 정상 작동하나, 정확한 이유를 몰라서 일단 안정성을 위해 다시 살려둠
          break;
        }
        case 'LOCALE_KO': {
          vm._changeLocale('ko'); // eslint-disable-line no-underscore-dangle
          break;
        }
        case 'LOCALE_EN': {
          vm._changeLocale('en'); // eslint-disable-line no-underscore-dangle
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    async Logo(flag) {
      const vm = this;
      if(flag && vm.logoSrc === '') {
      //회원의 소속에 따라 소속기관 이미지 삽입
      //주 소속기관 찾기
        const res = await userService.getUserBelongings();
        if(Object.keys(res.data).length !== 0 || res.data.constructor !== Object) {
          res.data.response.forEach(e => {
            if(e.main_belonging === 1) {
              vm.nologo = false;
              if(e.affiliation_id === 5000)
                vm.logoSrc = "https://scontent-ssn1-1.xx.fbcdn.net/v/t1.0-9/51221325_1997195293651137_9183682012144205824_n.jpg?_nc_cat=108&_nc_sid=85a577&_nc_ohc=voiweuoiIIgAX_fwwtz&_nc_ht=scontent-ssn1-1.xx&oh=196d452e0e7c0dccc1682775ada40cbc&oe=5EE1729B";
              else if (e.affiliation_id === 3000 || e.affiliation_id === 3100 || e.affiliation_id === 3101 || e.affiliation_id === 3102)
                vm.logoSrc = "https://ww.namu.la/s/03d9dc7e6af8e0422a837d47ac8daf71df727daceae07a7546322d556000e63094f24cd71fde3e058dafaec37fe2a7ddfded45aaca19447650cd4a9ffa27927bc966d6730c53df40b6a1d066081a7a6654bfed3c61207b1e965a1efb15094d3952d72ff96bf594c4930caca30a08c0e1";
              else if (e.affiliation_id === 4000) 
                vm.logoSrc = "https://media-exp1.licdn.com/dms/image/C510BAQHNtFgdmNuP4g/company-logo_200_200/0?e=2159024400&v=beta&t=ZEfCJCh3meQcK5r_gmhFvSFXC0GmGb7AW9BudiakKSI";
            }
          });
        }
        if(vm.logoSrc === '' || vm.logoSrc === undefined) {
          vm.nologo = true;
        }
      }
    },
    recordClick() {
      const vm = this;
      if (vm.recordingState) {
        vm.$listeners['stopRecord']();
      } else {
        vm.$listeners['startRecord']();
      }
    }
  },
  beforeDestroy() {
    const vm = this;
    clearInterval(vm.pingUpdateInterval);
  }
};
</script>
